// C Source File
// Created 12/22/2003; 6:31:24 PM

#define USE_TI89              // Compile for TI-89

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "Vars.h"
#include "Gfx Functions.h"

//01-13 = hearts
//14-26 = clubs
//27-39 = diamonds
//40-52 = spades

//suit structure
struct CARDS {
	int hearts[4];
	int clubs[4];
	int diamonds[4];
	int spades[4];
};
struct CARDS suits;

int check=0;

int back=0;
//static variables


//Functions

void disp_col(int y, int board[13][4]){
	int x,a;
	a=0;
	char *num="1";
	for (x=0; x<13; x++){
		if (board[x][y] == 0){
			a+=1;
			continue;
		}
		if(board[x][y]>39){
			if (board[x][y]==52){
				disp_spade((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"K",A_NORMAL);
			}else if (board[x][y]==51){
				disp_spade((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"Q",A_NORMAL);
			}else if (board[x][y]==50){
				disp_spade((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"J",A_NORMAL);
			}else if (board[x][y]==40){
				disp_spade((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"A",A_NORMAL);
			}else if (board[x][y]==53){
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"0",A_NORMAL);//I don't know why this is there, all I know is that without it, all the "A"'s will not display.
			}else{
				sprintf(num,"%d",board[x][y]-39);
				disp_spade((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,num,A_NORMAL);
			}
		}else if (board[x][y]>26){
			if (board[x][y]==39){
				disp_diamond((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"K",A_NORMAL);
			}else if (board[x][y]==38){
				disp_diamond((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"Q",A_NORMAL);
			}else if (board[x][y]==37){
				disp_diamond((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"J",A_NORMAL);
			}else if (board[x][y]==27){
				disp_diamond((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"A",A_NORMAL);
			}else{
				sprintf(num,"%d",board[x][y]-26);
				disp_diamond((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,num,A_NORMAL);
			}
		}else if (board[x][y]>13){
			if (board[x][y]==26){
				disp_club((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"K",A_NORMAL);
			}else if (board[x][y]==25){
				disp_club((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"Q",A_NORMAL);
			}else if (board[x][y]==24){
				disp_club((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"J",A_NORMAL);
			}else if (board[x][y]==14){
				disp_club((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"A",A_NORMAL);
			}else{
				sprintf(num,"%d",board[x][y]-13);
				disp_club((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,num,A_NORMAL);
			}
		}else{
			if (board[x][y]==13){
				disp_heart((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"K",A_NORMAL);
			}else if (board[x][y]==12){
				disp_heart((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"Q",A_NORMAL);
			}else if (board[x][y]==11){
				disp_heart((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"J",A_NORMAL);
			}else if (board[x][y]==1){
				disp_heart((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,"A",A_NORMAL);
			}else{
				sprintf(num,"%d",board[x][y]);
				disp_heart((y*24)+8+y,(x*8)-(a*8));
				DrawStr((y*24)+9+y,(x*8)-(a*8)+2,num,A_NORMAL);
			}
		}
	}
}

void col_shift(int row, int col, int board[13][4]){
	int x;
	for (x=12; x>=0; x--){
		board[x][col]=board[x-1][col];
	}
	board[0][col]=0;
	board[row][col]=0;
	blank_col(col);
	disp_col(col, board);
	if (board[row-1][col]>39){
		suits.spades[col]=board[row-1][col];
		suits.diamonds[col]=0;
		suits.clubs[col]=0;
		suits.hearts[col]=0;
	}else if (board[row-1][col]>26){
		suits.spades[col]=0;
		suits.diamonds[col]=board[row-1][col];
		suits.clubs[col]=0;
		suits.hearts[col]=0;
	}else if (board[row-1][col]>13){
		suits.spades[col]=0;
		suits.diamonds[col]=0;
		suits.clubs[col]=board[row-1][col];
		suits.hearts[col]=0;
	}else{
		suits.spades[col]=0;
		suits.diamonds[col]=0;
		suits.clubs[col]=0;
		suits.hearts[col]=board[row-1][col];
	}
}

void disp_board(int board[13][4]){
	int y;
	for (y=0; y<4; y++){
		disp_col(y, board);
	}
}

void draw(int board[13][4], int deck[52], int y){
	int num,x;
	for (x=0; x<4;x++){
		num = random(52);
		if (deck[num]==0){
			x-=1;
			continue;
		}
		board[y][x]=deck[num];
		deck[num]=0;
	}
	if (board[y][0]>=40){//slot one
		suits.spades[0]=board[y][0];
		suits.diamonds[0]=0;
		suits.clubs[0]=0;
		suits.hearts[0]=0;
	}else if (board[y][0]>=27){
		suits.spades[0]=0;
		suits.diamonds[0]=board[y][0];
		suits.clubs[0]=0;
		suits.hearts[0]=0;
	}else if (board[y][0]>=14){
		suits.spades[0]=0;
		suits.diamonds[0]=0;
		suits.clubs[0]=board[y][0];
		suits.hearts[0]=0;
	}else{
		suits.spades[0]=0;
		suits.diamonds[0]=0;
		suits.clubs[0]=0;
		suits.hearts[0]=board[y][0];
	}
	if (board[y][1]>=40){//slot two
		suits.spades[1]=board[y][1];
		suits.diamonds[1]=0;
		suits.clubs[1]=0;
		suits.hearts[1]=0;
	}else if (board[y][1]>=27){
		suits.spades[1]=0;
		suits.diamonds[1]=board[y][1];
		suits.clubs[1]=0;
		suits.hearts[1]=0;
	}else if (board[y][1]>=14){
		suits.spades[1]=0;
		suits.diamonds[1]=0;
		suits.clubs[1]=board[y][1];
		suits.hearts[1]=0;
	}else{
		suits.spades[1]=0;
		suits.diamonds[1]=0;
		suits.clubs[1]=0;
		suits.hearts[1]=board[y][1];
	}
	if (board[y][2]>=40){//slot three
		suits.spades[2]=board[y][2];
		suits.diamonds[2]=0;
		suits.clubs[2]=0;
		suits.hearts[2]=0;
	}else if (board[y][2]>=27){
		suits.spades[2]=0;
		suits.diamonds[2]=board[y][2];
		suits.clubs[2]=0;
		suits.hearts[2]=0;
	}else if (board[y][2]>=14){
		suits.spades[2]=0;
		suits.diamonds[2]=0;
		suits.clubs[2]=board[y][2];
		suits.hearts[2]=0;
	}else{
		suits.spades[2]=0;
		suits.diamonds[2]=0;
		suits.clubs[2]=0;
		suits.hearts[2]=board[y][2];
	}
	if (board[y][3]>=40){//slot four
		suits.spades[3]=board[y][3];
		suits.diamonds[3]=0;
		suits.clubs[3]=0;
		suits.hearts[3]=0;
	}else if (board[y][3]>=27){
		suits.spades[3]=0;
		suits.diamonds[3]=board[y][3];
		suits.clubs[3]=0;
		suits.hearts[3]=0;
	}else if (board[y][3]>=14){
		suits.spades[3]=0;
		suits.diamonds[3]=0;
		suits.clubs[3]=board[y][3];
		suits.hearts[3]=0;
	}else{
		suits.spades[3]=0;
		suits.diamonds[3]=0;
		suits.clubs[3]=0;
		suits.hearts[3]=board[y][3];
	}
	disp_board(board);
}

void move_card(int y, int cardo, int board[13][4]){
	int k,card1,card2,kk;
	k=ngetchx();
	kk=k-268;
	if (board[y-1][kk]>39){
		card2=board[y-1][kk]-39;
	}else if(board[y-1][kk]>26){
		card2=board[y-1][kk]-26;
	}else if(board[y-1][kk]>13){
		card2=board[y-1][kk]-13;
	}else{
		card2=board[y-1][kk];
	}
	if (board[y-1][cardo]>39){
		card1=board[y-1][cardo]-39;
	}else if(board[y-1][cardo]>26){
		card1=board[y-1][cardo]-26;
	}else if(board[y-1][cardo]>13){
		card1=board[y-1][cardo]-13;
	}else{
		card1=board[y-1][cardo];
	}
	if (cardo!=kk){
		if ((kk>-1 && kk<4) && board[y-1][kk]==0){
			if (board[y-1][cardo]>39){
				suits.spades[kk]=board[y-1][cardo];
			}else if(board[y-1][cardo]>26){
				suits.diamonds[kk]=board[y-1][cardo];
			}else if(board[y-1][cardo]>13){
				suits.clubs[kk]=board[y-1][cardo];
			}else{
				suits.hearts[kk]=board[y-1][cardo];
			}
			board[y-1][kk]=board[y-1][cardo];
			col_shift(y,cardo,board);
		}else{
			if (card1!=13 && card1==card2){
				board[y-1][kk]=0;
				board[y-1][cardo]=0;
				col_shift(y,kk,board);
				col_shift(y,cardo,board);
			}
		}
	}
	disp_board(board);
}

void draw_menu(void){
	ClrScr();
	FontSetSys(F_8x10);
	DrawClipRect (&rect1,&full_screen,A_NORMAL);
	DrawClipRect (&rect2,&full_screen,A_NORMAL);
	DrawClipRect (&rect3,&full_screen,A_NORMAL);
	BitmapPut(8,8,&cruel,&full_screen,A_NORMAL);
	DrawStr(64,40,"PLAY",A_NORMAL);
	DrawStr(53,50,"OPTIONS",A_NORMAL);
	DrawStr(53,60,"CREDITS",A_NORMAL);
	DrawStr(53,70,"RECORDS",A_NORMAL);
	DrawStr(64,80,"QUIT",A_NORMAL);
}
void check_end(int board[13][4]){
	int x,end[4];
	int checks[4]={13,13,13,13};
	for (x=0;x<4;x++){
		if (board[12][x]>39){
			end[x]=board[12][x]-39;
		}else if (board[12][x]>26){
			end[x]=board[12][x]-26;
		}else if (board[12][x]>13){
			end[x]=board[12][x]-13;
		}else{
			end[x]=board[12][x];
		}
	}
	if ((end[0]==checks[0] && end[1]==checks[1] && end[2]==checks[2] && end[3]==checks[3]) && (!board[11][0] && !board[11][1] && !board[11][2] && !board[11][3])){
		check=1;
	}
}

void game(void);

void options(void){
	int k,b;
	b=back;
	ClrScr();
	GrayOn();
	if (back==0){
		disp_hand_back(69,32);
	}else if (back==1){
		disp_palm_back(69,32);
	}else if (back==2){
		disp_fish_back(69,32);
	}else if (back==3){
		disp_shell_back(69,32);
	}
	DrawStr(36,8,"Choose Back",A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(0,90,"[ENTER]-Accept [ESC]-Cancel",A_NORMAL);
	while ((k=ngetchx())!=KEY_ENTER){
		if (back!=3 && k==KEY_RIGHT){
			back+=1;
		}else if (back!=0 && k==KEY_LEFT){
			back-=1;
		}else if (k==KEY_ESC){
			back=b;
			break;
		}
		if (back==0){	
			disp_hand_back(69,32);
		}else if (back==1){
			disp_palm_back(69,32);
		}else if (back==2){
			disp_fish_back(69,32);
		}else if (back==3){
			disp_shell_back(69,32);
		}
	}
	GrayOff(); 
}

void records(void){
	ClrScr();
	DrawStr(53,5,"Records",A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(0,34,"Wins:",A_NORMAL);
	DrawStr(0,47,"Losses:",A_NORMAL);
	DrawStr(0,60,"Total:",A_NORMAL);
	printf_xy(43,47,"%d",loss);
	printf_xy(31,34,"%d",win);
	printf_xy(37,60,"%d",win+loss);
	ngetchx();
}

void credits(void){
	clrscr();
	FontSetSys(F_6x8);
	printf("CRUEL v1.0 A product of\nVision Software.\nProgrammed By W A Hibdon 2004.  v1.0 finish date\n1/31/2004.\n");
	ngetchx();
	printf("Special thanks to Billy\nElla.  With out him, I\nwould not have the backs\nof the cards.  Also, the\ndevlopment of the game\nwould have been much\nslower, for I had him to\nbounce ideas off of.\n\n\n");
	ngetchx();
}

// Main Function
void _main(void){
	int k,pos,select;
	k=0;
	pos=0;
	select=1;
	draw_menu();
	BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
	while (k!=KEY_ESC){
		while (!kbhit()){
		}
		k=ngetchx();
		if (pos!=40 && k==KEY_DOWN){
			BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			pos+=10;
			BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			select+=1;
		}
		if (pos!=0 && k==KEY_UP){
			BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			pos-=10;
			BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			select-=1;
		}
		if (k==KEY_ENTER){
			if (select==1){
				check=0;
				game();
				draw_menu();
				BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			}else if (select==2){
				options();
				draw_menu();
				BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			}else if (select==3){
				credits();
				draw_menu();
				BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			}else if (select==4){
				records();
				draw_menu();
				BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			}else if (select==5){
				break;
			}
		}else{
		}
	}
}

void game(void)//used to me the _main function, but I changed my got damn mind!
{
	//Varialbes
	int deck[52]={
		1,2,3,4,5,6,7,8,9,10,11,12,13,
		14,15,16,17,18,19,20,21,22,23,24,25,26,
		27,28,29,30,31,32,33,34,35,36,37,38,39,
		40,41,42,43,44,45,46,47,48,49,50,51,52
	};
	int board[13][4]={
		{0,0,0,0},
		{0,0,0,0},
		{0,0,0,0},
		{0,0,0,0},
		{0,0,0,0},
		{0,0,0,0},
		{0,0,0,0},
		{0,0,0,0},
		{0,0,0,0},
		{0,0,0,0},
		{0,0,0,0},
		{0,0,0,0},
		{0,0,0,0}
	};
	int k,y,left;
	char *a;
	
	//initialization
	y=0;
	left=52;
	a="52";
	k=0;
	//Function Calls
	FontSetSys(F_6x8);
	ClrScr();
	GrayOn();
	randomize();
	disp_board(board);
	if (back==0){
		disp_hand_back(119,0);
	}else if (back==1){
		disp_palm_back(119,0);
	}else if (back==2){
		disp_fish_back(119,0);
	}else if (back==3){
		disp_shell_back(119,0);
	}
	sprintf(a,"%d",left);
	DrawStr(119,37,a,A_NORMAL);
	while (k!=-1){
		GraySetAMSPlane(LIGHT_PLANE);
		BitmapPut(0,93,&bottom,&full_screen,A_REPLACE);
		GraySetAMSPlane(DARK_PLANE);
		BitmapPut(0,93,&bottom,&full_screen,A_REPLACE);
		check_end(board);
		if (check==1){
			you_win();
			ngetchx();
			win+=1;
			break;
		}
		while (!kbhit()){	
		}
		k=ngetchx();
		if (k==KEY_F1){
			disp_marker(1,94);
			if (board[y-1][0]>39){
				if (suits.spades[0]!=0 && (suits.spades[0]<suits.spades[1] || suits.spades[0]<suits.spades[2] || suits.spades[0]<suits.spades[3])){
					col_shift(y,0,board);
				}else{
					move_card(y,0,board);
				}
			}else if (board[y-1][0]>26){
				if (suits.diamonds[0]!=0 && (suits.diamonds[0]<suits.diamonds[1] || suits.diamonds[0]<suits.diamonds[2] || suits.diamonds[0]<suits.diamonds[3])){
					col_shift(y,0,board);
				}else{
					move_card(y,0,board);
				}
			}else if (board[y-1][0]>13){
				if (suits.clubs[0]!=0 && (suits.clubs[0]<suits.clubs[1] || suits.clubs[0]<suits.clubs[2] || suits.clubs[0]<suits.clubs[3])){
					col_shift(y,0,board);
				}else{
					move_card(y,0,board);
				}
			}else{
				if (suits.hearts[0]!=0 && (suits.hearts[0]<suits.hearts[1] || suits.hearts[0]<suits.hearts[2] || suits.hearts[0]<suits.hearts[3])){
					col_shift(y,0,board);
				}else{
					move_card(y,0,board);
				}
			}
		}
		if (k==KEY_F2){
			disp_marker(33,94);
			if (board[y-1][1]>39){
				if (suits.spades[1]!=0 && (suits.spades[1]<suits.spades[0] || suits.spades[1]<suits.spades[2] || suits.spades[1]<suits.spades[3])){
					col_shift(y,1,board);
				}else{
					move_card(y,1,board);
				}
			}else if (board[y-1][1]>26){
				if (suits.diamonds[1]!=0 && (suits.diamonds[1]<suits.diamonds[0] || suits.diamonds[1]<suits.diamonds[2] || suits.diamonds[1]<suits.diamonds[3])){
					col_shift(y,1,board);
				}else{
					move_card(y,1,board);
				}
			}else if (board[y-1][1]>13){
				if (suits.clubs[1]!=0 && (suits.clubs[1]<suits.clubs[0] || suits.clubs[1]<suits.clubs[2] || suits.clubs[1]<suits.clubs[3])){
					col_shift(y,1,board);
				}else{
					move_card(y,1,board);
				}
			}else{
				if (suits.hearts[1]!=0 && (suits.hearts[1]<suits.hearts[0] || suits.hearts[1]<suits.hearts[2] || suits.hearts[1]<suits.hearts[3])){
					col_shift(y,1,board);
				}else{
					move_card(y,1,board);
				}
			}
		}
		if (k==KEY_F3){
			disp_marker(65,94);
			if (board[y-1][2]>39){
				if (suits.spades[2]!=0 && (suits.spades[2]<suits.spades[0] || suits.spades[2]<suits.spades[1] || suits.spades[2]<suits.spades[3])){
					col_shift(y,2,board);
				}else{
					move_card(y,2,board);
				}
			}else if (board[y-1][2]>26){
				if (suits.diamonds[2]!=0 && (suits.diamonds[2]<suits.diamonds[0] || suits.diamonds[2]<suits.diamonds[1] || suits.diamonds[2]<suits.diamonds[3])){
					col_shift(y,2,board);
				}else{
					move_card(y,2,board);
				}
			}else if (board[y-1][2]>13){
				if (suits.clubs[2]!=0 && (suits.clubs[2]<suits.clubs[0] || suits.clubs[2]<suits.clubs[1] || suits.clubs[2]<suits.clubs[3])){
					col_shift(y,2,board);
				}else{
					move_card(y,2,board);
				}
			}else{
				if (suits.hearts[2]!=0 && (suits.hearts[2]<suits.hearts[0] || suits.hearts[2]<suits.hearts[1] || suits.hearts[2]<suits.hearts[3])){
					col_shift(y,2,board);
				}else{
					move_card(y,2,board);
				}
			}
		}
		if (k==KEY_F4){
			disp_marker(97,94);
			if (board[y-1][3]>39){
				if (suits.spades[3]!=0 && (suits.spades[3]<suits.spades[0] || suits.spades[3]<suits.spades[1] || suits.spades[3]<suits.spades[2])){
					col_shift(y,3,board);
				}else{
					move_card(y,3,board);
				}
			}else if (board[y-1][3]>26){
				if (suits.diamonds[3]!=0 && (suits.diamonds[3]<suits.diamonds[0] || suits.diamonds[3]<suits.diamonds[1] || suits.diamonds[3]<suits.diamonds[2])){
					col_shift(y,3,board);
				}else{
					move_card(y,3,board);
				}
			}else if (board[y-1][3]>13){
				if (suits.clubs[3]!=0 && (suits.clubs[3]<suits.clubs[0] || suits.clubs[3]<suits.clubs[1] || suits.clubs[3]<suits.clubs[2])){
					col_shift(y,3,board);
				}else{
					move_card(y,3,board);
				}
			}else{
				if (suits.hearts[3]!=0 && (suits.hearts[3]<suits.hearts[0] || suits.hearts[3]<suits.hearts[1] || suits.hearts[3]<suits.hearts[2])){
					col_shift(y,3,board);
				}else{
					move_card(y,3,board);
				}
			}
		}
		if (k==KEY_F5 || k==KEY_ENTER){
			if (y==13){
				continue;
			}
			draw(board,deck,y);
			y+=1;
			left-=4;
			sprintf(a,"%d",left);
			DrawStr(125,37," ",A_REPLACE);
			DrawStr(119,37,a,A_REPLACE);
		}
		if (k==KEY_ESC){
			loss+=1;
			break;
		}
	}
	GrayOff();
}