// C Source File
// Created 3/13/2004; 1:53:21 PM

#define USE_TI89              // Compile for TI-89

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 101           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "graphics.h"
#include "Gfx functions.h"

// The plaing feild
unsigned short int board [13][4];
// The 52 cards that we call from.
unsigned char deck[52];
// Tells what row to stop at.
short int stop;
unsigned short int suit,key,left;
//suit structure
struct CARDS {
	int hearts[4];
	int clubs[4];
	int diamonds[4];
	int spades[4];
};
struct CARDS suits;

void setup (void);
const char* card (unsigned short int num);
void disp(void);
void disp_row_col(unsigned short int row, unsigned short int col);
void shift_col (unsigned short int col);
void disp_row (void);
void draw (void);
void move_card (int cardo);
void game (void);
void draw_menu(void);
void options(void);
void credits(void);
void records(void);

// Main Function
void _main(void)
{
	FolderGetCur(folder);
  FolderCur(SYMSTR("main"), TRUE);
  EM_moveSymFromExtMem(SYMSTR(filename), HS_NULL);
  if ((File = fopen(filename, "rb")) != NULL){
  	exist = 1;
  	fclose(File);
  }
  if (exist){
  	File = fopen(filename, "rb");
    fread(&win, sizeof(short), 1, File);
    fread(&loss, sizeof(short), 1, File);
    fread(&back, sizeof(short), 1, File);
    fclose(File);
  }
	int k,pos,select;
	k=0;
	pos=0;
	select=1;
	draw_menu();
	BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
	while (k!=KEY_ESC){
		while (!kbhit()){
		}
		k=ngetchx();
		if (pos!=40 && k==KEY_DOWN){
			BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			pos+=10;
			BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			select+=1;
		}
		if (pos!=0 && k==KEY_UP){
			BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			pos-=10;
			BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			select-=1;
		}
		if (k==KEY_ENTER){
			if (select==1){
				game();
				draw_menu();
				BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			}else if (select==2){
				options();
				draw_menu();
				BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			}else if (select==3){
				credits();
				draw_menu();
				BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			}else if (select==4){
				records();
				draw_menu();
				BitmapPut(6,39+pos,&block,ScrRect,A_XOR);
			}else if (select==5){
				break;
			}
		}else{
		}
	}
	File = fopen(filename, "wb");
  fwrite(&win, sizeof(short), 1, File);
  fwrite(&loss, sizeof(short), 1, File);
  fwrite(&back, sizeof(short), 1, File);
  fputc (0, File);
  fputs ("CRU", File);
  fputc (0, File);
  fputc (OTH_TAG, File);
  fclose(File);
  EM_moveSymToExtMem(SYMSTR(filename), HS_NULL);
  FolderCur(SYMSTR(folder), TRUE);
  exist=0;
}

// Displays The Records
void records(void){
	int k;
	ClrScr();
	DrawClipRect (&rect1,&full_screen,A_NORMAL);
	DrawClipRect (&rect2,&full_screen,A_NORMAL);
	DrawClipRect (&rect3,&full_screen,A_NORMAL);
	DrawStr(53,7,"Records",A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(6,34,"Wins:",A_NORMAL);
	DrawStr(6,47,"Losses:",A_NORMAL);
	DrawStr(6,60,"Total:",A_NORMAL);
	printf_xy(49,47,"%d",loss);
	printf_xy(37,34,"%d",win);
	printf_xy(42,60,"%d",win+loss);
	printf_xy(6,73,"[CLEAR]-Reset");
	k=ngetchx();
	if (k==KEY_CLEAR){
		win=0;
		loss=0;
	}
}

// Displays The Credits
void credits(void){
	clrscr();
	FontSetSys(F_6x8);
	printf("CRUEL v1.1 A product of\nVision Software.\nProgrammed By W A Hibdon 2004.  v1.0 finish date\n5/31/2004.\n");
	ngetchx();
	printf("Special thanks to Billy\nElla.  With out him, I\nwould not have the backs\nof the cards.  Also, the\ndevlopment of the game\nwould have been much\nslower, for I had him to\nbounce ideas off.\n\n\n");
	ngetchx();
}

// The options section
void options(void){
	int k,b;
	b=back;
	ClrScr();
	GrayOn();
	if (back==0){
		disp_hand_back(69,32);
	}else if (back==1){
		disp_palm_back(69,32);
	}else if (back==2){
		disp_fish_back(69,32);
	}else if (back==3){
		disp_shell_back(69,32);
	}
	GraySetAMSPlane(LIGHT_PLANE);
	DrawClipRect (&rect1,&full_screen,A_NORMAL);
	DrawClipRect (&rect2,&full_screen,A_NORMAL);
	DrawClipRect (&rect3,&full_screen,A_NORMAL);
	GraySetAMSPlane(DARK_PLANE);
	DrawClipRect (&rect1,&full_screen,A_NORMAL);
	DrawClipRect (&rect2,&full_screen,A_NORMAL);
	DrawClipRect (&rect3,&full_screen,A_NORMAL);
	DrawStr(36,8,"Choose Back",A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(6,70,"[ENTER]-Accept",A_NORMAL); DrawStr(6,80,"[ESC]-Cancel",A_NORMAL);
	while ((k=ngetchx())!=KEY_ENTER){
		if (back!=3 && k==KEY_RIGHT){
			back+=1;
		}else if (back!=0 && k==KEY_LEFT){
			back-=1;
		}else if (k==KEY_ESC){
			back=b;
			break;
		}
		if (back==0){	
			disp_hand_back(69,32);
		}else if (back==1){
			disp_palm_back(69,32);
		}else if (back==2){
			disp_fish_back(69,32);
		}else if (back==3){
			disp_shell_back(69,32);
		}
	}
	GrayOff(); 
}

// Draws the menu.
void draw_menu(void){
	ClrScr();
	FontSetSys(F_8x10);
	DrawClipRect (&rect1,&full_screen,A_NORMAL);
	DrawClipRect (&rect2,&full_screen,A_NORMAL);
	DrawClipRect (&rect3,&full_screen,A_NORMAL);
	BitmapPut(8,8,&cruel,&full_screen,A_NORMAL);
	DrawStr(64,40,"PLAY",A_NORMAL);
	DrawStr(53,50,"OPTIONS",A_NORMAL);
	DrawStr(53,60,"CREDITS",A_NORMAL);
	DrawStr(53,70,"RECORDS",A_NORMAL);
	DrawStr(64,80,"QUIT",A_NORMAL);
}

// Checks if the game is finished.
int check_end(void){
	int x,end[4];
	int checks[4]={13,13,13,13};
	for (x=0;x<4;x++){
		if (board[12][x]>39){
			end[x]=board[12][x]-39;
		}else if (board[12][x]>26){
			end[x]=board[12][x]-26;
		}else if (board[12][x]>13){
			end[x]=board[12][x]-13;
		}else{
			end[x]=board[12][x];
		}
	}
	if ((end[0]==checks[0] && end[1]==checks[1] && end[2]==checks[2] && end[3]==checks[3]) && (!board[11][0] && !board[11][1] && !board[11][2] && !board[11][3])){
		return 1;
	}
	return 0;
}

// Where the game play takes place.
void game(void)
{
	setup ();
	ClrScr ();
	GrayOn ();
	FontSetSys(F_6x8);
	GraySetAMSPlane(LIGHT_PLANE);
	DrawClipRect (&rect1,&full_screen,A_NORMAL);
	DrawClipRect (&rect2,&full_screen,A_NORMAL);
	DrawClipRect (&rect3,&full_screen,A_NORMAL);
	GraySetAMSPlane(DARK_PLANE);
	DrawClipRect (&rect1,&full_screen,A_NORMAL);
	DrawClipRect (&rect2,&full_screen,A_NORMAL);
	DrawClipRect (&rect3,&full_screen,A_NORMAL);
	if (back==0){
		disp_hand_back(119,6);
	}else if (back==1){
		disp_palm_back(119,6);
	}else if (back==2){
		disp_fish_back(119,6);
	}else if (back==3){
		disp_shell_back(119,6);
	}
	printf_xy (119, 43, "%d", left);
	while (key!=KEY_ESC){
		DrawStr (119, 43, "  ", A_REPLACE);
		printf_xy (119, 43, "%d", left);
		GraySetAMSPlane(LIGHT_PLANE);
		BitmapPut(0,93,&bottom,&full_screen,A_REPLACE);
		GraySetAMSPlane(DARK_PLANE);
		BitmapPut(0,93,&bottom,&full_screen,A_REPLACE);
		if (check_end ()){
			you_win();
			ngetchx();
			win+=1;
			break;
		}
		while (!kbhit()){}
		key=ngetchx();
		if (board[stop][0]!=0 && key == KEY_F1)
		{
			disp_marker(1,94);
			if (board[stop][0]>=40 && board[stop][0]<=52){
				if (suits.spades[0]!=0 && (suits.spades[0]<suits.spades[1] || suits.spades[0]<suits.spades[2] || suits.spades[0]<suits.spades[3])){
					shift_col(0);
				}else{
					move_card(0);
				}
			}else if (board[stop][0]>=27 && board[stop][0]<=39){
				if (suits.diamonds[0]!=0 && (suits.diamonds[0]<suits.diamonds[1] || suits.diamonds[0]<suits.diamonds[2] || suits.diamonds[0]<suits.diamonds[3])){
					shift_col (0);
				}else{
					move_card (0);
				}
			}else if (board[stop][0]>=14 && board[stop][0]<=26){
				if (suits.clubs[0]!=0 && (suits.clubs[0]<suits.clubs[1] || suits.clubs[0]<suits.clubs[2] || suits.clubs[0]<suits.clubs[3])){
					shift_col (0);
				}else{
					move_card (0);
				}
			}else if (board[stop][0]>=1 && board[stop][0]<=13){
				if (suits.hearts[0]!=0 && (suits.hearts[0]<suits.hearts[1] || suits.hearts[0]<suits.hearts[2] || suits.hearts[0]<suits.hearts[3])){
					shift_col (0);
				}else{
					move_card (0);
				}
			}
			disp_marker (1,94);
		}
		if (board[stop][1]!=0 && key == KEY_F2)
		{
			disp_marker(33,94);
			if (board[stop][1]>=40 && board[stop][1]<=52){
				if (suits.spades[1]!=0 && (suits.spades[0]>suits.spades[1] || suits.spades[1]<suits.spades[2] || suits.spades[1]<suits.spades[3])){
					shift_col(1);
				}else{
					move_card(1);
				}
			}else if (board[stop][1]>=27 && board[stop][1]<=39){
				if (suits.diamonds[1]!=0 && (suits.diamonds[0]>suits.diamonds[1] || suits.diamonds[1]<suits.diamonds[2] || suits.diamonds[1]<suits.diamonds[3])){
					shift_col (1);
				}else{
					move_card (1);
				}
			}else if (board[stop][1]>=14 && board[stop][1]<=26){
				if (suits.clubs[1]!=0 && (suits.clubs[0]>suits.clubs[1] || suits.clubs[1]<suits.clubs[2] || suits.clubs[1]<suits.clubs[3])){
					shift_col (1);
				}else{
					move_card (1);
				}
			}else if (board[stop][1]>=1 && board[stop][1]<=13){
				if (suits.hearts[1]!=0 && (suits.hearts[0]>suits.hearts[1] || suits.hearts[1]<suits.hearts[2] || suits.hearts[1]<suits.hearts[3])){
					shift_col (1);
				}else{
					move_card (1);
				}
			}
			disp_marker (33,94);
		}
		if (board[stop][2]!=0 && key == KEY_F3)
		{
			disp_marker(65,94);
			if (board[stop][2]>=40 && board[stop][2]<=52){
				if (suits.spades[2]!=0 && (suits.spades[2]<suits.spades[1] || suits.spades[0]>suits.spades[2] || suits.spades[2]<suits.spades[3])){
					shift_col(2);
				}else{
					move_card(2);
				}
			}else if (board[stop][2]>=27 && board[stop][2]<=39){
				if (suits.diamonds[2]!=0 && (suits.diamonds[2]<suits.diamonds[1] || suits.diamonds[0]>suits.diamonds[2] || suits.diamonds[2]<suits.diamonds[3])){
					shift_col (2);
				}else{
					move_card (2);
				}
			}else if (board[stop][2]>=14 && board[stop][2]<=26){
				if (suits.clubs[2]!=0 && (suits.clubs[2]<suits.clubs[1] || suits.clubs[0]>suits.clubs[2] || suits.clubs[2]<suits.clubs[3])){
					shift_col (2);
				}else{
					move_card (2);
				}
			}else if (board[stop][2]>=1 && board[stop][2]<=13){
				if (suits.hearts[2]!=0 && (suits.hearts[2]<suits.hearts[1] || suits.hearts[0]>suits.hearts[2] || suits.hearts[2]<suits.hearts[3])){
					shift_col (2);
				}else{
					move_card (2);
				}
			}
			disp_marker (65,94);
		}
		if (board[stop][3]!=0 && key == KEY_F4)
		{
			disp_marker(97,94);
			if (board[stop][3]>=40 && board[stop][3]<=52){
				if (suits.spades[3]!=0 && (suits.spades[3]<suits.spades[1] || suits.spades[3]<suits.spades[2] || suits.spades[0]>suits.spades[3])){
					shift_col(3);
				}else{
					move_card(3);
				}
			}else if (board[stop][3]>=27 && board[stop][3]<=39){
				if (suits.diamonds[3]!=0 && (suits.diamonds[3]<suits.diamonds[1] || suits.diamonds[3]<suits.diamonds[2] || suits.diamonds[0]>suits.diamonds[3])){
					shift_col (3);
				}else{
					move_card (3);
				}
			}else if (board[stop][3]>=14 && board[stop][3]<=26){
				if (suits.clubs[3]!=0 && (suits.clubs[3]<suits.clubs[1] || suits.clubs[3]<suits.clubs[2] || suits.clubs[0]>suits.clubs[3])){
					shift_col (3);
				}else{
					move_card (3);
				}
			}else if (board[stop][3]>=1 && board[stop][3]<=13){
				if (suits.hearts[3]!=0 && (suits.hearts[3]<suits.hearts[1] || suits.hearts[3]<suits.hearts[2] || suits.hearts[0]>suits.hearts[3])){
					shift_col (3);
				}else{
					move_card (3);
				}
			}
			disp_marker (97,94);
		}
		if (stop!=12 && key==KEY_F5)
		{
			draw ();
			disp_row ();
			left-=4;
		}
	}
	GrayOff ();
}

////////////////////////////////////////////////////////////////////////////
// Basically gets everything to whaere it needs to be, before one starts. //
////////////////////////////////////////////////////////////////////////////
void setup(void)
{
	left = 52;
	stop = -1;
	suit = 0;
	memcpy(deck,(unsigned char[52]){1,2,3,4,5,6,7,8,9,10,11,12,13,
		14,15,16,17,18,19,20,21,22,23,24,25,26,
		27,28,29,30,31,32,33,34,35,36,37,38,39,
		40,41,42,43,44,45,46,47,48,49,50,51,52},52);
	memcpy(board,(unsigned short int [13][4]){{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
		{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
		{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
		{0,0,0,0}},52);
}

/////////////////////////////
// Displays specific card. //
/////////////////////////////
void disp_row_col(unsigned short int row_end, unsigned short int col)
{
	unsigned short int row, zero=0;
	for (row=0; row<=row_end; row++)
	{
		if (board[row][col]==0) // Checks if there is an empty space.
		{
			zero++; // Adds to what needs to be subtracted.
		}
	}
	if (board[row_end][col]>=1 && board[row_end][col]<=13){
		disp_heart ((col*24)+8+col, row_end*8-zero*8+6);
	}else if (board[row_end][col]>=14 && board[row_end][col]<=26){
		disp_club ((col*24)+8+col, row_end*8-zero*8+6);
	}else if (board[row_end][col]>=27 && board[row_end][col]<=39){
		disp_diamond ((col*24)+8+col, row_end*8-zero*8+6);
	}else if (board[row_end][col]>=40 && board[row_end][col]<=52){
		disp_spade ((col*24)+8+col, row_end*8-zero*8+6);
	}else if (board[row_end][col]==0){
		disp_blank ((col*24)+8+col, row_end*8-zero*8+14);
	}
	printf_xy ((col*24)+9+col, row_end*8-zero*8+6+2, card(board[row_end][col]));
}

////////////////////////////////////////////////
// Shifts cards in column 'col' one row down. //
////////////////////////////////////////////////
void shift_col (unsigned short int col)
{
	unsigned short int row;
	for (row=stop; row>0; row--)
	{
		board [row][col]=board [row-1][col];
	}
	board [0][col] = 0;
	if (board[stop][col]>=40 && board[stop][col]<=52){
		suits.spades[col]=board[stop][col];
		suits.diamonds[col]=0;
		suits.clubs[col]=0;
		suits.hearts[col]=0;
	}else if (board[stop][col]>=27 && board[stop][col]<=39){
		suits.spades[col]=0;
		suits.diamonds[col]=board[stop][col];
		suits.clubs[col]=0;
		suits.hearts[col]=0;
	}else if (board[stop][col]>=14 && board[stop][col]<=26){
		suits.spades[col]=0;
		suits.diamonds[col]=0;
		suits.clubs[col]=board[stop][col];
		suits.hearts[col]=0;
	}else if (board[stop][col]>=1 && board[stop][col]<=13){
		suits.spades[col]=0;
		suits.diamonds[col]=0;
		suits.clubs[col]=0;
		suits.hearts[col]=board[stop][col];
	}
	disp_row_col (stop, col);
}

///////////////////////
// Displays one row. //
///////////////////////
void disp_row (void)
{
	disp_row_col (stop, 0);
	disp_row_col (stop, 1);
	disp_row_col (stop, 2);
	disp_row_col (stop, 3);
}

////////////////////////////////////////////////////////
// Draws four cards, and places them in the stop row. //
////////////////////////////////////////////////////////
void draw (void)
{
	stop++;
	randomize();
	unsigned short int num, col;
	for (col=0; col<4; col++)
	{
		num=random (52);
		if (deck [num]==0)
		{
			col--;
		}else
		{
			board [stop][col]=deck [num];
			deck [num]=0;
			if (board[stop][col]>=40 && board[stop][col]<=52){
				suits.spades[col]=board[stop][col];
				suits.diamonds[col]=0;
				suits.clubs[col]=0;
				suits.hearts[col]=0;
			}else if (board[stop][col]>=27 && board[stop][col]<=39){
				suits.spades[col]=0;
				suits.diamonds[col]=board[stop][col];
				suits.clubs[col]=0;
				suits.hearts[col]=0;
			}else if (board[stop][col]>=14 && board[stop][col]<=26){
				suits.spades[col]=0;
				suits.diamonds[col]=0;
				suits.clubs[col]=board[stop][col];
				suits.hearts[col]=0;
			}else if (board[stop][col]>=1 && board[stop][col]<=13){
				suits.spades[col]=0;
				suits.diamonds[col]=0;
				suits.clubs[col]=0;
				suits.hearts[col]=board[stop][col];
			}
		}
	}
}

/////////////////////////////////////////////////////
// Turns a number into the card that it refers to. //
// 1-13 Hearts                                     //
// 14-26 Clubs                                     //
// 27-39 Diamonds                                  //
// 40-52 Spades                                    //
/////////////////////////////////////////////////////
const char* card (unsigned short int num)
{
	static char left_over[4];
	if (num>=1 && num<=13)
	{
		if (num==1)
		{
			return "A";
		}else if (num==11){
			return "J";
		}else if (num==12){
			return "Q";
		}else if (num==13){
			return "K";
		}else{
			sprintf (left_over, "%d", num);
			return left_over;
		}
	}else if (num>=14 && num<=26){
		if (num==14)
		{
			return "A";
		}else if (num==24){
			return "J";
		}else if (num==25){
			return "Q";
		}else if (num==26){
			return "K";
		}else{
			sprintf (left_over, "%d", num-13);
			return left_over;
		}
	}else if (num>=27 && num<=39){
		if (num==27)
		{
			return "A";
		}else if (num==37){
			return "J";
		}else if (num==38){
			return "Q";
		}else if (num==39){
			return "K";
		}else{
			sprintf (left_over, "%d", num-26);
			return left_over;
		}
	}else if (num>=40 && num<=52){
		if (num==40)
		{
			return "A";
		}else if (num==50){
			return "J";
		}else if (num==51){
			return "Q";
		}else if (num==52){
			return "K";
		}else{
			sprintf (left_over, "%d", num-39);
			return left_over;
		}
	}else if (num==0){
		return "";
	}
	return "Something Fucked Up";
}

void move_card(int cardo){
	int k,card1,card2,kk;
	k=ngetchx();
	kk=k-268;
	if (board[stop][kk]>39){
		card2=board[stop][kk]-39;
	}else if(board[stop][kk]>26){
		card2=board[stop][kk]-26;
	}else if(board[stop][kk]>13){
		card2=board[stop][kk]-13;
	}else{
		card2=board[stop][kk];
	}
	if (board[stop][cardo]>39){
		card1=board[stop][cardo]-39;
	}else if(board[stop][cardo]>26){
		card1=board[stop][cardo]-26;
	}else if(board[stop][cardo]>13){
		card1=board[stop][cardo]-13;
	}else{
		card1=board[stop][cardo];
	}
	if (cardo!=kk){
		if ((kk>=0 && kk<=3) && board[stop][kk]==0){
			if (board[stop][cardo]>39){
				suits.spades[kk]=board[stop][cardo];
			}else if(board[stop][cardo]>26){
				suits.diamonds[kk]=board[stop][cardo];
			}else if(board[stop][cardo]>13){
				suits.clubs[kk]=board[stop][cardo];
			}else{
				suits.hearts[kk]=board[stop][cardo];
			}
			board[stop][kk]=board[stop][cardo];
			shift_col(cardo);
			disp_row_col (stop, kk);
		}else{
			if (card1!=13 && card1==card2){
				board[stop][kk]=0;
				board[stop][cardo]=0;
				shift_col (kk);
				shift_col (cardo);
			}
		}
	}
}